/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the
edition of Beamer documents

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
* Class MyDictionary
* For storing dictionaries. Based on HashSet
* Creation: 2009
* @version 1.1 10/11/2009
* @author Ludovic APVRILLE
* @see
*/

package myutil;

import java.io.*;
import java.util.*;

public class MyDictionary  {
	private HashSet values;
	private int nbOfWords;
	private String name;
	private boolean selected;
	
    public MyDictionary(String _name) {
		values = new HashSet();
		nbOfWords = 0;
		name = _name;
		selected = true;
    }
	
	public String getName() {
		return name;
	}
	
	public void setSelected(boolean _b) {
		selected = _b;
	}
	
	public boolean isSelected() {
		return selected;
	}
    
    public int loadFromFile(String path) {
		String s = "", line;
		File file = new File(path);
		
		// Loading String
		if(FileUtils.checkFileForOpen(file)) {
            try {
                FileInputStream fis = new FileInputStream(file);
                int nb = fis.available();
                
                byte [] ba = new byte[nb];
                fis.read(ba);
                fis.close();
                s = new String(ba);
            } catch(Exception e) {
                System.out.println("File could not be opened:" + e.getMessage());
                return -1;
            }
		}
		

		// Reading string
		StringReader sr = new StringReader(s);
        BufferedReader br = new BufferedReader(sr);
		char c;
		try {
			while((line = br.readLine()) != null) {
				line = line.trim();
				addToDictionary(line);
				if (line.length() > 1) {
					addToDictionary(line.substring(0, 1).toUpperCase() + line.substring(1, line.length()));
				} else {
					addToDictionary(line.toUpperCase());
				}
			}
		} catch(Exception e) {
			System.out.println("Error when making dictionary: " + e.getMessage());
		}
		
		return getNbOfWords();
    }
	
	public HashSet getDictionaryHash() {
		return values;
	}       
	
	public int getNbOfWords() {
		return nbOfWords;
	}
	
	public void addToDictionary(String _word) {
		values.add(_word);
		nbOfWords ++;
	}
    
}
