/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the
edition of Latex documents

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
* Class Autosave
* Autosave of files
* Creation: 11/06/2010
* @version 1.0 11/06/2010
* @author Ludovic APVRILLE
* @see 
*/

package ui;

import java.io.*;
import java.util.*;
import javax.swing.*;

import latexstructure.*;
import myutil.*;
//import java.awt.*;
//import java.awt.event.*;


public class Autosave implements Runnable {
	
    protected MainGUI mgui;
	protected Thread t;
	protected boolean go = true;
	
    
    public Autosave(MainGUI _mgui) {
        mgui = _mgui;
        t = new Thread(this);
		t.start();
    }
	
	public void run() {
		LatexStructure ls;
		String previous = "";
		String current;
		String name;
		File file, f;
		LinkedList<EditionSet> editions;
		
		while(go) {
			
			try {
				Thread.currentThread().sleep(60000);
			} catch (InterruptedException ie) {
			}
			
			if (go) {
				editions = mgui.getEditionSet();
				for(EditionSet es: editions) {
					ls = es.getLatexStructure();
					f = es.getFile();
					//System.out.println("Autosave");
					if (ls != null) {
						if (f == null) {
							mgui.setStatusBarText("Autosaving failed: project not saved");
						} else {
							current = ls.getText();
							if (current.compareTo(previous) != 0) {
								previous = current;
								mgui.setStatusBarText("Autosaving in");
								name = f.getAbsolutePath();
								name += "~";
								file = new File(name);
								name = saveFile(file, current);
								mgui.setStatusBarText(name);
							} else {
								mgui.setStatusBarText("Nothing new to autosave");
							}
						}
					}
				}
			}
		}
	}
	
	public String saveFile(File _f, String _data) {
		try {
			if(FileUtils.checkFileForSave(_f)) {
				
                if (_data == null) {
                    return "No data to save";
                }
                FileOutputStream fos = new FileOutputStream(_f);
                fos.write(_data.getBytes());
                fos.close();
                return "Autosaved done in " + _f.getAbsolutePath();
			} else {
				return "File cannot be used";
			}
		} catch(Exception e) {
			return "Autosaved failed: " + e.getMessage();
		}
	}
    
} // Class





